
definition module repository

import StdEnv, Corba


////////////////////////////////
//     CORBA_Identifier
////////////////////////////////

:: CORBA_Identifier :== CORBA_String
CORBA_Identifier__tc :: TypeCode
CORBA_Identifier__repoid 	:==	 "IDL:omg.org/CORBA/Identifier:1.0"
CORBA_Identifier__name 	:==	 "Identifier"
CORBA_Identifier__decode :== CORBA_String__decode
CORBA_Identifier__encode :== CORBA_String__encode

////////////////////////////////
//     CORBA_VersionSpec
////////////////////////////////

:: CORBA_VersionSpec :== CORBA_String
CORBA_VersionSpec__tc :: TypeCode
CORBA_VersionSpec__repoid 	:==	 "IDL:omg.org/CORBA/VersionSpec:1.0"
CORBA_VersionSpec__name 	:==	 "VersionSpec"
CORBA_VersionSpec__decode :== CORBA_String__decode
CORBA_VersionSpec__encode :== CORBA_String__encode

////////////////////////////////
//     CORBA_RepositoryId
////////////////////////////////

:: CORBA_RepositoryId :== CORBA_String
CORBA_RepositoryId__tc :: TypeCode
CORBA_RepositoryId__repoid 	:==	 "IDL:omg.org/CORBA/RepositoryId:1.0"
CORBA_RepositoryId__name 	:==	 "RepositoryId"
CORBA_RepositoryId__decode :== CORBA_String__decode
CORBA_RepositoryId__encode :== CORBA_String__encode

////////////////////////////////
//     CORBA_DefinitionKind
////////////////////////////////

:: CORBA_DefinitionKind = Dk_none
	| Dk_all
	| Dk_Attribute
	| Dk_Constant
	| Dk_Exception
	| Dk_Interface
	| Dk_Module
	| Dk_Operation
	| Dk_Typedef
	| Dk_Alias
	| Dk_Struct
	| Dk_Union
	| Dk_Enum
	| Dk_Primitive
	| Dk_String
	| Dk_Sequence
	| Dk_Array
	| Dk_Repository
	| Dk_Wstring
	| Dk_Fixed
	| Dk_Value
	| Dk_ValueBox
	| Dk_ValueMember
	| Dk_Native
CORBA_DefinitionKind__tc :: TypeCode
CORBA_DefinitionKind__repoid 	:==	 "IDL:omg.org/CORBA/DefinitionKind:1.0"
CORBA_DefinitionKind__name 	:==	 "DefinitionKind"
CORBA_DefinitionKind__decode :: Any *World -> (MayBe CORBA_DefinitionKind, *World)
CORBA_DefinitionKind__encode :: CORBA_DefinitionKind -> Any

instance == CORBA_DefinitionKind

instance toString CORBA_DefinitionKind

////////////////////////////////
//     CORBA_IRObject
////////////////////////////////

:: CORBA_IRObject  = { reference :: CORBA_Object }
CORBA_IRObject__tc 	 :: TypeCode
CORBA_IRObject__repoid 	:==	 "IDL:omg.org/CORBA/IRObject:1.0"
CORBA_IRObject__name 	:==	 "IRObject"
CORBA_IRObject__decode :: Any *World -> (MayBe CORBA_IRObject, *World)
CORBA_IRObject__encode :: CORBA_IRObject -> Any
CORBA_IRObject__nil :: *World -> (CORBA_IRObject, *World)
class CORBA_IRObject__narrow_class a where
	CORBA_IRObject__narrow :: a *World -> (MayBe CORBA_IRObject, *World)
instance CORBA_IRObject__narrow_class CORBA_Object

class CORBA_IRObject__widen_class a where
	CORBA_IRObject__widen :: a -> CORBA_IRObject

instance CORBA_Object__widen_class CORBA_IRObject

CORBA_IRObject__get_def_kind :: CORBA_IRObject  *World
	-> ((ResultOrException CORBA_DefinitionKind CorbaException), *World)

CORBA_IRObject_destroy :: CORBA_IRObject  *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_IDLType
////////////////////////////////

:: CORBA_IDLType  = { reference :: CORBA_Object }
CORBA_IDLType__tc 	 :: TypeCode
CORBA_IDLType__repoid 	:==	 "IDL:omg.org/CORBA/IDLType:1.0"
CORBA_IDLType__name 	:==	 "IDLType"
CORBA_IDLType__decode :: Any *World -> (MayBe CORBA_IDLType, *World)
CORBA_IDLType__encode :: CORBA_IDLType -> Any
CORBA_IDLType__nil :: *World -> (CORBA_IDLType, *World)
class CORBA_IDLType__narrow_class a where
	CORBA_IDLType__narrow :: a *World -> (MayBe CORBA_IDLType, *World)
instance CORBA_IDLType__narrow_class CORBA_IRObject
instance CORBA_IDLType__narrow_class CORBA_Object

class CORBA_IDLType__widen_class a where
	CORBA_IDLType__widen :: a -> CORBA_IDLType

instance CORBA_IRObject__widen_class CORBA_IDLType

instance CORBA_Object__widen_class CORBA_IDLType

CORBA_IDLType__get_type :: CORBA_IDLType  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

////////////////////////////////
//     CORBA_StructMember
////////////////////////////////

:: CORBA_StructMember = {
	name :: CORBA_Identifier,
	type :: CORBA_TypeCode,
	type_def :: CORBA_IDLType
	}
CORBA_StructMember__tc :: TypeCode
CORBA_StructMember__repoid 	:==	 "IDL:omg.org/CORBA/StructMember:1.0"
CORBA_StructMember__name 	:==	 "StructMember"
CORBA_StructMember__decode :: Any *World -> (MayBe CORBA_StructMember, *World)
CORBA_StructMember__encode :: CORBA_StructMember -> Any

////////////////////////////////
//     CORBA_StructMemberSeq
////////////////////////////////

:: CORBA_StructMemberSeq :== [CORBA_StructMember]
CORBA_StructMemberSeq__tc :: TypeCode
CORBA_StructMemberSeq__decode :: Any *World -> (MayBe CORBA_StructMemberSeq, *World)
CORBA_StructMemberSeq__encode :: CORBA_StructMemberSeq -> Any

////////////////////////////////
//     CORBA_UnionMember
////////////////////////////////

:: CORBA_UnionMember = {
	name :: CORBA_Identifier,
	label :: CORBA_Any,
	type :: CORBA_TypeCode,
	type_def :: CORBA_IDLType
	}
CORBA_UnionMember__tc :: TypeCode
CORBA_UnionMember__repoid 	:==	 "IDL:omg.org/CORBA/UnionMember:1.0"
CORBA_UnionMember__name 	:==	 "UnionMember"
CORBA_UnionMember__decode :: Any *World -> (MayBe CORBA_UnionMember, *World)
CORBA_UnionMember__encode :: CORBA_UnionMember -> Any

////////////////////////////////
//     CORBA_UnionMemberSeq
////////////////////////////////

:: CORBA_UnionMemberSeq :== [CORBA_UnionMember]
CORBA_UnionMemberSeq__tc :: TypeCode
CORBA_UnionMemberSeq__decode :: Any *World -> (MayBe CORBA_UnionMemberSeq, *World)
CORBA_UnionMemberSeq__encode :: CORBA_UnionMemberSeq -> Any

////////////////////////////////
//     CORBA_EnumMemberSeq
////////////////////////////////

:: CORBA_EnumMemberSeq :== [CORBA_Identifier]
CORBA_EnumMemberSeq__tc :: TypeCode
CORBA_EnumMemberSeq__decode :: Any *World -> (MayBe CORBA_EnumMemberSeq, *World)
CORBA_EnumMemberSeq__encode :: CORBA_EnumMemberSeq -> Any

////////////////////////////////
//     CORBA_Visibility
////////////////////////////////

:: CORBA_Visibility :== CORBA_Short
CORBA_Visibility__tc :: TypeCode
CORBA_Visibility__repoid 	:==	 "IDL:omg.org/CORBA/Visibility:1.0"
CORBA_Visibility__name 	:==	 "Visibility"
CORBA_Visibility__decode :== CORBA_Short__decode
CORBA_Visibility__encode :== CORBA_Short__encode

CORBA_PRIVATE_MEMBER :== 0

CORBA_PUBLIC_MEMBER :== 1

////////////////////////////////
//     CORBA_ValueModifier
////////////////////////////////

:: CORBA_ValueModifier :== CORBA_Short
CORBA_ValueModifier__tc :: TypeCode
CORBA_ValueModifier__repoid 	:==	 "IDL:omg.org/CORBA/ValueModifier:1.0"
CORBA_ValueModifier__name 	:==	 "ValueModifier"
CORBA_ValueModifier__decode :== CORBA_Short__decode
CORBA_ValueModifier__encode :== CORBA_Short__encode

CORBA_VM_NONE :== 0

CORBA_VM_CUSTOM :== 1

CORBA_VM_ABSTRACT :== 2

CORBA_VM_TRUNCATABLE :== 3

////////////////////////////////
//     CORBA_ValueMember
////////////////////////////////

:: CORBA_ValueMember = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	type :: CORBA_TypeCode,
	type_def :: CORBA_IDLType,
	access :: CORBA_Visibility
	}
CORBA_ValueMember__tc :: TypeCode
CORBA_ValueMember__repoid 	:==	 "IDL:omg.org/CORBA/ValueMember:1.0"
CORBA_ValueMember__name 	:==	 "ValueMember"
CORBA_ValueMember__decode :: Any *World -> (MayBe CORBA_ValueMember, *World)
CORBA_ValueMember__encode :: CORBA_ValueMember -> Any

////////////////////////////////
//     CORBA_ValueMemberSeq
////////////////////////////////

:: CORBA_ValueMemberSeq :== [CORBA_ValueMember]
CORBA_ValueMemberSeq__tc :: TypeCode
CORBA_ValueMemberSeq__decode :: Any *World -> (MayBe CORBA_ValueMemberSeq, *World)
CORBA_ValueMemberSeq__encode :: CORBA_ValueMemberSeq -> Any

////////////////////////////////
//     CORBA_ScopedName
////////////////////////////////

:: CORBA_ScopedName :== CORBA_String
CORBA_ScopedName__tc :: TypeCode
CORBA_ScopedName__repoid 	:==	 "IDL:omg.org/CORBA/ScopedName:1.0"
CORBA_ScopedName__name 	:==	 "ScopedName"
CORBA_ScopedName__decode :== CORBA_String__decode
CORBA_ScopedName__encode :== CORBA_String__encode

////////////////////////////////
//     CORBA_Contained
////////////////////////////////

:: CORBA_Contained  = { reference :: CORBA_Object }
CORBA_Contained__tc 	 :: TypeCode
CORBA_Contained__repoid 	:==	 "IDL:omg.org/CORBA/Contained:1.0"
CORBA_Contained__name 	:==	 "Contained"
CORBA_Contained__decode :: Any *World -> (MayBe CORBA_Contained, *World)
CORBA_Contained__encode :: CORBA_Contained -> Any
CORBA_Contained__nil :: *World -> (CORBA_Contained, *World)
class CORBA_Contained__narrow_class a where
	CORBA_Contained__narrow :: a *World -> (MayBe CORBA_Contained, *World)
instance CORBA_Contained__narrow_class CORBA_IRObject
instance CORBA_Contained__narrow_class CORBA_Object

class CORBA_Contained__widen_class a where
	CORBA_Contained__widen :: a -> CORBA_Contained

instance CORBA_IRObject__widen_class CORBA_Contained

instance CORBA_Object__widen_class CORBA_Contained

CORBA_Contained__get_id :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_RepositoryId CorbaException), *World)

CORBA_Contained__set_id :: CORBA_Contained CORBA_RepositoryId *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_Contained__get_name :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_Identifier CorbaException), *World)

CORBA_Contained__set_name :: CORBA_Contained CORBA_Identifier *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_Contained__get_version :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_VersionSpec CorbaException), *World)

CORBA_Contained__set_version :: CORBA_Contained CORBA_VersionSpec *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_Contained__get_defined_in :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_Container CorbaException), *World)

CORBA_Contained__get_absolute_name :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_ScopedName CorbaException), *World)

CORBA_Contained__get_containing_repository :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_Repository CorbaException), *World)

////////////////////////////////
//     CORBA_Contained_Description
////////////////////////////////

:: CORBA_Contained_Description = {
	kind :: CORBA_DefinitionKind,
	value :: CORBA_Any
	}
CORBA_Contained_Description__tc :: TypeCode
CORBA_Contained_Description__repoid 	:==	 "IDL:omg.org/CORBA/Contained/Description:1.0"
CORBA_Contained_Description__name 	:==	 "Description"
CORBA_Contained_Description__decode :: Any *World -> (MayBe CORBA_Contained_Description, *World)
CORBA_Contained_Description__encode :: CORBA_Contained_Description -> Any

CORBA_Contained_describe :: CORBA_Contained  *World
	-> ((ResultOrException CORBA_Contained_Description CorbaException), *World)

CORBA_Contained_move :: CORBA_Contained CORBA_Container CORBA_Identifier CORBA_VersionSpec *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_ValueDefSeq
////////////////////////////////

:: CORBA_ValueDefSeq :== [CORBA_ValueDef]
CORBA_ValueDefSeq__tc :: TypeCode
CORBA_ValueDefSeq__decode :: Any *World -> (MayBe CORBA_ValueDefSeq, *World)
CORBA_ValueDefSeq__encode :: CORBA_ValueDefSeq -> Any

////////////////////////////////
//     CORBA_InterfaceDefSeq
////////////////////////////////

:: CORBA_InterfaceDefSeq :== [CORBA_InterfaceDef]
CORBA_InterfaceDefSeq__tc :: TypeCode
CORBA_InterfaceDefSeq__decode :: Any *World -> (MayBe CORBA_InterfaceDefSeq, *World)
CORBA_InterfaceDefSeq__encode :: CORBA_InterfaceDefSeq -> Any

////////////////////////////////
//     CORBA_ContainedSeq
////////////////////////////////

:: CORBA_ContainedSeq :== [CORBA_Contained]
CORBA_ContainedSeq__tc :: TypeCode
CORBA_ContainedSeq__decode :: Any *World -> (MayBe CORBA_ContainedSeq, *World)
CORBA_ContainedSeq__encode :: CORBA_ContainedSeq -> Any

////////////////////////////////
//     CORBA_Initializer
////////////////////////////////

:: CORBA_Initializer = {
	members :: CORBA_StructMemberSeq,
	name :: CORBA_Identifier
	}
CORBA_Initializer__tc :: TypeCode
CORBA_Initializer__repoid 	:==	 "IDL:omg.org/CORBA/Initializer:1.0"
CORBA_Initializer__name 	:==	 "Initializer"
CORBA_Initializer__decode :: Any *World -> (MayBe CORBA_Initializer, *World)
CORBA_Initializer__encode :: CORBA_Initializer -> Any

////////////////////////////////
//     CORBA_InitializerSeq
////////////////////////////////

:: CORBA_InitializerSeq :== [CORBA_Initializer]
CORBA_InitializerSeq__tc :: TypeCode
CORBA_InitializerSeq__decode :: Any *World -> (MayBe CORBA_InitializerSeq, *World)
CORBA_InitializerSeq__encode :: CORBA_InitializerSeq -> Any

////////////////////////////////
//     CORBA_Container
////////////////////////////////

:: CORBA_Container  = { reference :: CORBA_Object }
CORBA_Container__tc 	 :: TypeCode
CORBA_Container__repoid 	:==	 "IDL:omg.org/CORBA/Container:1.0"
CORBA_Container__name 	:==	 "Container"
CORBA_Container__decode :: Any *World -> (MayBe CORBA_Container, *World)
CORBA_Container__encode :: CORBA_Container -> Any
CORBA_Container__nil :: *World -> (CORBA_Container, *World)
class CORBA_Container__narrow_class a where
	CORBA_Container__narrow :: a *World -> (MayBe CORBA_Container, *World)
instance CORBA_Container__narrow_class CORBA_IRObject
instance CORBA_Container__narrow_class CORBA_Object

class CORBA_Container__widen_class a where
	CORBA_Container__widen :: a -> CORBA_Container

instance CORBA_IRObject__widen_class CORBA_Container

instance CORBA_Object__widen_class CORBA_Container

CORBA_Container_lookup :: CORBA_Container CORBA_ScopedName *World
	-> ((ResultOrException CORBA_Contained CorbaException), *World)

CORBA_Container_contents :: CORBA_Container CORBA_DefinitionKind CORBA_Boolean *World
	-> ((ResultOrException CORBA_ContainedSeq CorbaException), *World)

CORBA_Container_lookup_name :: CORBA_Container CORBA_Identifier CORBA_Long CORBA_DefinitionKind CORBA_Boolean *World
	-> ((ResultOrException CORBA_ContainedSeq CorbaException), *World)

////////////////////////////////
//     CORBA_Container_Description
////////////////////////////////

:: CORBA_Container_Description = {
	contained_object :: CORBA_Contained,
	kind :: CORBA_DefinitionKind,
	value :: CORBA_Any
	}
CORBA_Container_Description__tc :: TypeCode
CORBA_Container_Description__repoid 	:==	 "IDL:omg.org/CORBA/Container/Description:1.0"
CORBA_Container_Description__name 	:==	 "Description"
CORBA_Container_Description__decode :: Any *World -> (MayBe CORBA_Container_Description, *World)
CORBA_Container_Description__encode :: CORBA_Container_Description -> Any

////////////////////////////////
//     CORBA_Container_DescriptionSeq
////////////////////////////////

:: CORBA_Container_DescriptionSeq :== [CORBA_Container_Description]
CORBA_Container_DescriptionSeq__tc :: TypeCode
CORBA_Container_DescriptionSeq__decode :: Any *World -> (MayBe CORBA_Container_DescriptionSeq, *World)
CORBA_Container_DescriptionSeq__encode :: CORBA_Container_DescriptionSeq -> Any

CORBA_Container_describe_contents :: CORBA_Container CORBA_DefinitionKind CORBA_Boolean CORBA_Long *World
	-> ((ResultOrException CORBA_Container_DescriptionSeq CorbaException), *World)

CORBA_Container_create_module :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec *World
	-> ((ResultOrException CORBA_ModuleDef CorbaException), *World)

CORBA_Container_create_constant :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_Any *World
	-> ((ResultOrException CORBA_ConstantDef CorbaException), *World)

CORBA_Container_create_struct :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_StructMemberSeq *World
	-> ((ResultOrException CORBA_StructDef CorbaException), *World)

CORBA_Container_create_exception :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_StructMemberSeq *World
	-> ((ResultOrException CORBA_ExceptionDef CorbaException), *World)

CORBA_Container_create_union :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_UnionMemberSeq *World
	-> ((ResultOrException CORBA_UnionDef CorbaException), *World)

CORBA_Container_create_enum :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_EnumMemberSeq *World
	-> ((ResultOrException CORBA_EnumDef CorbaException), *World)

CORBA_Container_create_alias :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType *World
	-> ((ResultOrException CORBA_AliasDef CorbaException), *World)

CORBA_Container_create_interface :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_InterfaceDefSeq CORBA_Boolean *World
	-> ((ResultOrException CORBA_InterfaceDef CorbaException), *World)

CORBA_Container_create_value :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_Boolean CORBA_Boolean CORBA_ValueDef CORBA_Boolean CORBA_ValueDefSeq CORBA_InterfaceDefSeq CORBA_InitializerSeq *World
	-> ((ResultOrException CORBA_ValueDef CorbaException), *World)

CORBA_Container_create_value_box :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType *World
	-> ((ResultOrException CORBA_ValueBoxDef CorbaException), *World)

CORBA_Container_create_native :: CORBA_Container CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec *World
	-> ((ResultOrException CORBA_NativeDef CorbaException), *World)

CORBA_Container_find :: CORBA_Container CORBA_ScopedName *World
	-> ((ResultOrException CORBA_Contained CorbaException), *World)

CORBA_Container_find_name :: CORBA_Container CORBA_Identifier CORBA_DefinitionKind *World
	-> ((ResultOrException CORBA_ContainedSeq CorbaException), *World)

CORBA_Container_locate_id :: CORBA_Container CORBA_RepositoryId *World
	-> ((ResultOrException CORBA_Contained CorbaException), *World)

CORBA_Container_locate_name :: CORBA_Container CORBA_Identifier CORBA_Boolean CORBA_Boolean *World
	-> ((ResultOrException CORBA_Contained CorbaException), *World)

CORBA_Container_remove_contained :: CORBA_Container CORBA_Contained *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_Container_add_contained :: CORBA_Container CORBA_Contained *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_PrimitiveKind
////////////////////////////////

:: CORBA_PrimitiveKind = Pk_null
	| Pk_void
	| Pk_short
	| Pk_long
	| Pk_ushort
	| Pk_ulong
	| Pk_float
	| Pk_double
	| Pk_boolean
	| Pk_char
	| Pk_octet
	| Pk_any
	| Pk_TypeCode
	| Pk_Principal
	| Pk_string
	| Pk_objref
	| Pk_longlong
	| Pk_ulonglong
	| Pk_longdouble
	| Pk_wchar
	| Pk_wstring
	| Pk_value_base
CORBA_PrimitiveKind__tc :: TypeCode
CORBA_PrimitiveKind__repoid 	:==	 "IDL:omg.org/CORBA/PrimitiveKind:1.0"
CORBA_PrimitiveKind__name 	:==	 "PrimitiveKind"
CORBA_PrimitiveKind__decode :: Any *World -> (MayBe CORBA_PrimitiveKind, *World)
CORBA_PrimitiveKind__encode :: CORBA_PrimitiveKind -> Any

instance == CORBA_PrimitiveKind

instance toString CORBA_PrimitiveKind

////////////////////////////////
//     CORBA_Repository
////////////////////////////////

:: CORBA_Repository  = { reference :: CORBA_Object }
CORBA_Repository__tc 	 :: TypeCode
CORBA_Repository__repoid 	:==	 "IDL:omg.org/CORBA/Repository:1.0"
CORBA_Repository__name 	:==	 "Repository"
CORBA_Repository__decode :: Any *World -> (MayBe CORBA_Repository, *World)
CORBA_Repository__encode :: CORBA_Repository -> Any
CORBA_Repository__nil :: *World -> (CORBA_Repository, *World)
class CORBA_Repository__narrow_class a where
	CORBA_Repository__narrow :: a *World -> (MayBe CORBA_Repository, *World)
instance CORBA_Repository__narrow_class CORBA_Container
instance CORBA_Repository__narrow_class CORBA_Object

class CORBA_Repository__widen_class a where
	CORBA_Repository__widen :: a -> CORBA_Repository

instance CORBA_Container__widen_class CORBA_Repository

instance CORBA_Object__widen_class CORBA_Repository

CORBA_Repository_lookup_id :: CORBA_Repository CORBA_RepositoryId *World
	-> ((ResultOrException CORBA_Contained CorbaException), *World)

CORBA_Repository_get_primitive :: CORBA_Repository CORBA_PrimitiveKind *World
	-> ((ResultOrException CORBA_PrimitiveDef CorbaException), *World)

CORBA_Repository_create_string :: CORBA_Repository CORBA_ULong *World
	-> ((ResultOrException CORBA_StringDef CorbaException), *World)

CORBA_Repository_create_wstring :: CORBA_Repository CORBA_ULong *World
	-> ((ResultOrException CORBA_WstringDef CorbaException), *World)

CORBA_Repository_create_sequence :: CORBA_Repository CORBA_ULong CORBA_IDLType *World
	-> ((ResultOrException CORBA_SequenceDef CorbaException), *World)

CORBA_Repository_create_array :: CORBA_Repository CORBA_ULong CORBA_IDLType *World
	-> ((ResultOrException CORBA_ArrayDef CorbaException), *World)

CORBA_Repository_create_fixed :: CORBA_Repository CORBA_UShort CORBA_Short *World
	-> ((ResultOrException CORBA_FixedDef CorbaException), *World)

////////////////////////////////
//     CORBA_ModuleDef
////////////////////////////////

:: CORBA_ModuleDef  = { reference :: CORBA_Object }
CORBA_ModuleDef__tc 	 :: TypeCode
CORBA_ModuleDef__repoid 	:==	 "IDL:omg.org/CORBA/ModuleDef:1.0"
CORBA_ModuleDef__name 	:==	 "ModuleDef"
CORBA_ModuleDef__decode :: Any *World -> (MayBe CORBA_ModuleDef, *World)
CORBA_ModuleDef__encode :: CORBA_ModuleDef -> Any
CORBA_ModuleDef__nil :: *World -> (CORBA_ModuleDef, *World)
class CORBA_ModuleDef__narrow_class a where
	CORBA_ModuleDef__narrow :: a *World -> (MayBe CORBA_ModuleDef, *World)
instance CORBA_ModuleDef__narrow_class CORBA_Container
instance CORBA_ModuleDef__narrow_class CORBA_Contained
instance CORBA_ModuleDef__narrow_class CORBA_Object

class CORBA_ModuleDef__widen_class a where
	CORBA_ModuleDef__widen :: a -> CORBA_ModuleDef

instance CORBA_Container__widen_class CORBA_ModuleDef

instance CORBA_Contained__widen_class CORBA_ModuleDef

instance CORBA_Object__widen_class CORBA_ModuleDef

////////////////////////////////
//     CORBA_ModuleDescription
////////////////////////////////

:: CORBA_ModuleDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec
	}
CORBA_ModuleDescription__tc :: TypeCode
CORBA_ModuleDescription__repoid 	:==	 "IDL:omg.org/CORBA/ModuleDescription:1.0"
CORBA_ModuleDescription__name 	:==	 "ModuleDescription"
CORBA_ModuleDescription__decode :: Any *World -> (MayBe CORBA_ModuleDescription, *World)
CORBA_ModuleDescription__encode :: CORBA_ModuleDescription -> Any

////////////////////////////////
//     CORBA_ConstantDef
////////////////////////////////

:: CORBA_ConstantDef  = { reference :: CORBA_Object }
CORBA_ConstantDef__tc 	 :: TypeCode
CORBA_ConstantDef__repoid 	:==	 "IDL:omg.org/CORBA/ConstantDef:1.0"
CORBA_ConstantDef__name 	:==	 "ConstantDef"
CORBA_ConstantDef__decode :: Any *World -> (MayBe CORBA_ConstantDef, *World)
CORBA_ConstantDef__encode :: CORBA_ConstantDef -> Any
CORBA_ConstantDef__nil :: *World -> (CORBA_ConstantDef, *World)
class CORBA_ConstantDef__narrow_class a where
	CORBA_ConstantDef__narrow :: a *World -> (MayBe CORBA_ConstantDef, *World)
instance CORBA_ConstantDef__narrow_class CORBA_Contained
instance CORBA_ConstantDef__narrow_class CORBA_Object

class CORBA_ConstantDef__widen_class a where
	CORBA_ConstantDef__widen :: a -> CORBA_ConstantDef

instance CORBA_Contained__widen_class CORBA_ConstantDef

instance CORBA_Object__widen_class CORBA_ConstantDef

CORBA_ConstantDef__get_type :: CORBA_ConstantDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_ConstantDef__get_type_def :: CORBA_ConstantDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_ConstantDef__set_type_def :: CORBA_ConstantDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ConstantDef__get_value :: CORBA_ConstantDef  *World
	-> ((ResultOrException CORBA_Any CorbaException), *World)

CORBA_ConstantDef__set_value :: CORBA_ConstantDef CORBA_Any *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_ConstantDescription
////////////////////////////////

:: CORBA_ConstantDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	type :: CORBA_TypeCode,
	value :: CORBA_Any
	}
CORBA_ConstantDescription__tc :: TypeCode
CORBA_ConstantDescription__repoid 	:==	 "IDL:omg.org/CORBA/ConstantDescription:1.0"
CORBA_ConstantDescription__name 	:==	 "ConstantDescription"
CORBA_ConstantDescription__decode :: Any *World -> (MayBe CORBA_ConstantDescription, *World)
CORBA_ConstantDescription__encode :: CORBA_ConstantDescription -> Any

////////////////////////////////
//     CORBA_TypedefDef
////////////////////////////////

:: CORBA_TypedefDef  = { reference :: CORBA_Object }
CORBA_TypedefDef__tc 	 :: TypeCode
CORBA_TypedefDef__repoid 	:==	 "IDL:omg.org/CORBA/TypedefDef:1.0"
CORBA_TypedefDef__name 	:==	 "TypedefDef"
CORBA_TypedefDef__decode :: Any *World -> (MayBe CORBA_TypedefDef, *World)
CORBA_TypedefDef__encode :: CORBA_TypedefDef -> Any
CORBA_TypedefDef__nil :: *World -> (CORBA_TypedefDef, *World)
class CORBA_TypedefDef__narrow_class a where
	CORBA_TypedefDef__narrow :: a *World -> (MayBe CORBA_TypedefDef, *World)
instance CORBA_TypedefDef__narrow_class CORBA_Contained
instance CORBA_TypedefDef__narrow_class CORBA_IDLType
instance CORBA_TypedefDef__narrow_class CORBA_Object

class CORBA_TypedefDef__widen_class a where
	CORBA_TypedefDef__widen :: a -> CORBA_TypedefDef

instance CORBA_Contained__widen_class CORBA_TypedefDef

instance CORBA_IDLType__widen_class CORBA_TypedefDef

instance CORBA_Object__widen_class CORBA_TypedefDef

////////////////////////////////
//     CORBA_TypeDescription
////////////////////////////////

:: CORBA_TypeDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	type :: CORBA_TypeCode
	}
CORBA_TypeDescription__tc :: TypeCode
CORBA_TypeDescription__repoid 	:==	 "IDL:omg.org/CORBA/TypeDescription:1.0"
CORBA_TypeDescription__name 	:==	 "TypeDescription"
CORBA_TypeDescription__decode :: Any *World -> (MayBe CORBA_TypeDescription, *World)
CORBA_TypeDescription__encode :: CORBA_TypeDescription -> Any

////////////////////////////////
//     CORBA_StructDef
////////////////////////////////

:: CORBA_StructDef  = { reference :: CORBA_Object }
CORBA_StructDef__tc 	 :: TypeCode
CORBA_StructDef__repoid 	:==	 "IDL:omg.org/CORBA/StructDef:1.0"
CORBA_StructDef__name 	:==	 "StructDef"
CORBA_StructDef__decode :: Any *World -> (MayBe CORBA_StructDef, *World)
CORBA_StructDef__encode :: CORBA_StructDef -> Any
CORBA_StructDef__nil :: *World -> (CORBA_StructDef, *World)
class CORBA_StructDef__narrow_class a where
	CORBA_StructDef__narrow :: a *World -> (MayBe CORBA_StructDef, *World)
instance CORBA_StructDef__narrow_class CORBA_TypedefDef
instance CORBA_StructDef__narrow_class CORBA_Container
instance CORBA_StructDef__narrow_class CORBA_Object

class CORBA_StructDef__widen_class a where
	CORBA_StructDef__widen :: a -> CORBA_StructDef

instance CORBA_TypedefDef__widen_class CORBA_StructDef

instance CORBA_Container__widen_class CORBA_StructDef

instance CORBA_Object__widen_class CORBA_StructDef

CORBA_StructDef__get_members :: CORBA_StructDef  *World
	-> ((ResultOrException CORBA_StructMemberSeq CorbaException), *World)

CORBA_StructDef__set_members :: CORBA_StructDef CORBA_StructMemberSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_UnionDef
////////////////////////////////

:: CORBA_UnionDef  = { reference :: CORBA_Object }
CORBA_UnionDef__tc 	 :: TypeCode
CORBA_UnionDef__repoid 	:==	 "IDL:omg.org/CORBA/UnionDef:1.0"
CORBA_UnionDef__name 	:==	 "UnionDef"
CORBA_UnionDef__decode :: Any *World -> (MayBe CORBA_UnionDef, *World)
CORBA_UnionDef__encode :: CORBA_UnionDef -> Any
CORBA_UnionDef__nil :: *World -> (CORBA_UnionDef, *World)
class CORBA_UnionDef__narrow_class a where
	CORBA_UnionDef__narrow :: a *World -> (MayBe CORBA_UnionDef, *World)
instance CORBA_UnionDef__narrow_class CORBA_TypedefDef
instance CORBA_UnionDef__narrow_class CORBA_Container
instance CORBA_UnionDef__narrow_class CORBA_Object

class CORBA_UnionDef__widen_class a where
	CORBA_UnionDef__widen :: a -> CORBA_UnionDef

instance CORBA_TypedefDef__widen_class CORBA_UnionDef

instance CORBA_Container__widen_class CORBA_UnionDef

instance CORBA_Object__widen_class CORBA_UnionDef

CORBA_UnionDef__get_discriminator_type :: CORBA_UnionDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_UnionDef__get_discriminator_type_def :: CORBA_UnionDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_UnionDef__set_discriminator_type_def :: CORBA_UnionDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_UnionDef__get_members :: CORBA_UnionDef  *World
	-> ((ResultOrException CORBA_UnionMemberSeq CorbaException), *World)

CORBA_UnionDef__set_members :: CORBA_UnionDef CORBA_UnionMemberSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_EnumDef
////////////////////////////////

:: CORBA_EnumDef  = { reference :: CORBA_Object }
CORBA_EnumDef__tc 	 :: TypeCode
CORBA_EnumDef__repoid 	:==	 "IDL:omg.org/CORBA/EnumDef:1.0"
CORBA_EnumDef__name 	:==	 "EnumDef"
CORBA_EnumDef__decode :: Any *World -> (MayBe CORBA_EnumDef, *World)
CORBA_EnumDef__encode :: CORBA_EnumDef -> Any
CORBA_EnumDef__nil :: *World -> (CORBA_EnumDef, *World)
class CORBA_EnumDef__narrow_class a where
	CORBA_EnumDef__narrow :: a *World -> (MayBe CORBA_EnumDef, *World)
instance CORBA_EnumDef__narrow_class CORBA_TypedefDef
instance CORBA_EnumDef__narrow_class CORBA_Object

class CORBA_EnumDef__widen_class a where
	CORBA_EnumDef__widen :: a -> CORBA_EnumDef

instance CORBA_TypedefDef__widen_class CORBA_EnumDef

instance CORBA_Object__widen_class CORBA_EnumDef

CORBA_EnumDef__get_members :: CORBA_EnumDef  *World
	-> ((ResultOrException CORBA_EnumMemberSeq CorbaException), *World)

CORBA_EnumDef__set_members :: CORBA_EnumDef CORBA_EnumMemberSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_AliasDef
////////////////////////////////

:: CORBA_AliasDef  = { reference :: CORBA_Object }
CORBA_AliasDef__tc 	 :: TypeCode
CORBA_AliasDef__repoid 	:==	 "IDL:omg.org/CORBA/AliasDef:1.0"
CORBA_AliasDef__name 	:==	 "AliasDef"
CORBA_AliasDef__decode :: Any *World -> (MayBe CORBA_AliasDef, *World)
CORBA_AliasDef__encode :: CORBA_AliasDef -> Any
CORBA_AliasDef__nil :: *World -> (CORBA_AliasDef, *World)
class CORBA_AliasDef__narrow_class a where
	CORBA_AliasDef__narrow :: a *World -> (MayBe CORBA_AliasDef, *World)
instance CORBA_AliasDef__narrow_class CORBA_TypedefDef
instance CORBA_AliasDef__narrow_class CORBA_Object

class CORBA_AliasDef__widen_class a where
	CORBA_AliasDef__widen :: a -> CORBA_AliasDef

instance CORBA_TypedefDef__widen_class CORBA_AliasDef

instance CORBA_Object__widen_class CORBA_AliasDef

CORBA_AliasDef__get_original_type_def :: CORBA_AliasDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_AliasDef__set_original_type_def :: CORBA_AliasDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_NativeDef
////////////////////////////////

:: CORBA_NativeDef  = { reference :: CORBA_Object }
CORBA_NativeDef__tc 	 :: TypeCode
CORBA_NativeDef__repoid 	:==	 "IDL:omg.org/CORBA/NativeDef:1.0"
CORBA_NativeDef__name 	:==	 "NativeDef"
CORBA_NativeDef__decode :: Any *World -> (MayBe CORBA_NativeDef, *World)
CORBA_NativeDef__encode :: CORBA_NativeDef -> Any
CORBA_NativeDef__nil :: *World -> (CORBA_NativeDef, *World)
class CORBA_NativeDef__narrow_class a where
	CORBA_NativeDef__narrow :: a *World -> (MayBe CORBA_NativeDef, *World)
instance CORBA_NativeDef__narrow_class CORBA_TypedefDef
instance CORBA_NativeDef__narrow_class CORBA_Object

class CORBA_NativeDef__widen_class a where
	CORBA_NativeDef__widen :: a -> CORBA_NativeDef

instance CORBA_TypedefDef__widen_class CORBA_NativeDef

instance CORBA_Object__widen_class CORBA_NativeDef

////////////////////////////////
//     CORBA_PrimitiveDef
////////////////////////////////

:: CORBA_PrimitiveDef  = { reference :: CORBA_Object }
CORBA_PrimitiveDef__tc 	 :: TypeCode
CORBA_PrimitiveDef__repoid 	:==	 "IDL:omg.org/CORBA/PrimitiveDef:1.0"
CORBA_PrimitiveDef__name 	:==	 "PrimitiveDef"
CORBA_PrimitiveDef__decode :: Any *World -> (MayBe CORBA_PrimitiveDef, *World)
CORBA_PrimitiveDef__encode :: CORBA_PrimitiveDef -> Any
CORBA_PrimitiveDef__nil :: *World -> (CORBA_PrimitiveDef, *World)
class CORBA_PrimitiveDef__narrow_class a where
	CORBA_PrimitiveDef__narrow :: a *World -> (MayBe CORBA_PrimitiveDef, *World)
instance CORBA_PrimitiveDef__narrow_class CORBA_IDLType
instance CORBA_PrimitiveDef__narrow_class CORBA_Object

class CORBA_PrimitiveDef__widen_class a where
	CORBA_PrimitiveDef__widen :: a -> CORBA_PrimitiveDef

instance CORBA_IDLType__widen_class CORBA_PrimitiveDef

instance CORBA_Object__widen_class CORBA_PrimitiveDef

CORBA_PrimitiveDef__get_kind :: CORBA_PrimitiveDef  *World
	-> ((ResultOrException CORBA_PrimitiveKind CorbaException), *World)

////////////////////////////////
//     CORBA_StringDef
////////////////////////////////

:: CORBA_StringDef  = { reference :: CORBA_Object }
CORBA_StringDef__tc 	 :: TypeCode
CORBA_StringDef__repoid 	:==	 "IDL:omg.org/CORBA/StringDef:1.0"
CORBA_StringDef__name 	:==	 "StringDef"
CORBA_StringDef__decode :: Any *World -> (MayBe CORBA_StringDef, *World)
CORBA_StringDef__encode :: CORBA_StringDef -> Any
CORBA_StringDef__nil :: *World -> (CORBA_StringDef, *World)
class CORBA_StringDef__narrow_class a where
	CORBA_StringDef__narrow :: a *World -> (MayBe CORBA_StringDef, *World)
instance CORBA_StringDef__narrow_class CORBA_IDLType
instance CORBA_StringDef__narrow_class CORBA_Object

class CORBA_StringDef__widen_class a where
	CORBA_StringDef__widen :: a -> CORBA_StringDef

instance CORBA_IDLType__widen_class CORBA_StringDef

instance CORBA_Object__widen_class CORBA_StringDef

CORBA_StringDef__get_bound :: CORBA_StringDef  *World
	-> ((ResultOrException CORBA_ULong CorbaException), *World)

CORBA_StringDef__set_bound :: CORBA_StringDef CORBA_ULong *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_WstringDef
////////////////////////////////

:: CORBA_WstringDef  = { reference :: CORBA_Object }
CORBA_WstringDef__tc 	 :: TypeCode
CORBA_WstringDef__repoid 	:==	 "IDL:omg.org/CORBA/WstringDef:1.0"
CORBA_WstringDef__name 	:==	 "WstringDef"
CORBA_WstringDef__decode :: Any *World -> (MayBe CORBA_WstringDef, *World)
CORBA_WstringDef__encode :: CORBA_WstringDef -> Any
CORBA_WstringDef__nil :: *World -> (CORBA_WstringDef, *World)
class CORBA_WstringDef__narrow_class a where
	CORBA_WstringDef__narrow :: a *World -> (MayBe CORBA_WstringDef, *World)
instance CORBA_WstringDef__narrow_class CORBA_IDLType
instance CORBA_WstringDef__narrow_class CORBA_Object

class CORBA_WstringDef__widen_class a where
	CORBA_WstringDef__widen :: a -> CORBA_WstringDef

instance CORBA_IDLType__widen_class CORBA_WstringDef

instance CORBA_Object__widen_class CORBA_WstringDef

CORBA_WstringDef__get_bound :: CORBA_WstringDef  *World
	-> ((ResultOrException CORBA_ULong CorbaException), *World)

CORBA_WstringDef__set_bound :: CORBA_WstringDef CORBA_ULong *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_FixedDef
////////////////////////////////

:: CORBA_FixedDef  = { reference :: CORBA_Object }
CORBA_FixedDef__tc 	 :: TypeCode
CORBA_FixedDef__repoid 	:==	 "IDL:omg.org/CORBA/FixedDef:1.0"
CORBA_FixedDef__name 	:==	 "FixedDef"
CORBA_FixedDef__decode :: Any *World -> (MayBe CORBA_FixedDef, *World)
CORBA_FixedDef__encode :: CORBA_FixedDef -> Any
CORBA_FixedDef__nil :: *World -> (CORBA_FixedDef, *World)
class CORBA_FixedDef__narrow_class a where
	CORBA_FixedDef__narrow :: a *World -> (MayBe CORBA_FixedDef, *World)
instance CORBA_FixedDef__narrow_class CORBA_IDLType
instance CORBA_FixedDef__narrow_class CORBA_Object

class CORBA_FixedDef__widen_class a where
	CORBA_FixedDef__widen :: a -> CORBA_FixedDef

instance CORBA_IDLType__widen_class CORBA_FixedDef

instance CORBA_Object__widen_class CORBA_FixedDef

CORBA_FixedDef__get_digits :: CORBA_FixedDef  *World
	-> ((ResultOrException CORBA_UShort CorbaException), *World)

CORBA_FixedDef__set_digits :: CORBA_FixedDef CORBA_UShort *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_FixedDef__get_scale :: CORBA_FixedDef  *World
	-> ((ResultOrException CORBA_Short CorbaException), *World)

CORBA_FixedDef__set_scale :: CORBA_FixedDef CORBA_Short *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_SequenceDef
////////////////////////////////

:: CORBA_SequenceDef  = { reference :: CORBA_Object }
CORBA_SequenceDef__tc 	 :: TypeCode
CORBA_SequenceDef__repoid 	:==	 "IDL:omg.org/CORBA/SequenceDef:1.0"
CORBA_SequenceDef__name 	:==	 "SequenceDef"
CORBA_SequenceDef__decode :: Any *World -> (MayBe CORBA_SequenceDef, *World)
CORBA_SequenceDef__encode :: CORBA_SequenceDef -> Any
CORBA_SequenceDef__nil :: *World -> (CORBA_SequenceDef, *World)
class CORBA_SequenceDef__narrow_class a where
	CORBA_SequenceDef__narrow :: a *World -> (MayBe CORBA_SequenceDef, *World)
instance CORBA_SequenceDef__narrow_class CORBA_IDLType
instance CORBA_SequenceDef__narrow_class CORBA_Object

class CORBA_SequenceDef__widen_class a where
	CORBA_SequenceDef__widen :: a -> CORBA_SequenceDef

instance CORBA_IDLType__widen_class CORBA_SequenceDef

instance CORBA_Object__widen_class CORBA_SequenceDef

CORBA_SequenceDef__get_bound :: CORBA_SequenceDef  *World
	-> ((ResultOrException CORBA_ULong CorbaException), *World)

CORBA_SequenceDef__set_bound :: CORBA_SequenceDef CORBA_ULong *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_SequenceDef__get_element_type :: CORBA_SequenceDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_SequenceDef__get_element_type_def :: CORBA_SequenceDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_SequenceDef__set_element_type_def :: CORBA_SequenceDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_ArrayDef
////////////////////////////////

:: CORBA_ArrayDef  = { reference :: CORBA_Object }
CORBA_ArrayDef__tc 	 :: TypeCode
CORBA_ArrayDef__repoid 	:==	 "IDL:omg.org/CORBA/ArrayDef:1.0"
CORBA_ArrayDef__name 	:==	 "ArrayDef"
CORBA_ArrayDef__decode :: Any *World -> (MayBe CORBA_ArrayDef, *World)
CORBA_ArrayDef__encode :: CORBA_ArrayDef -> Any
CORBA_ArrayDef__nil :: *World -> (CORBA_ArrayDef, *World)
class CORBA_ArrayDef__narrow_class a where
	CORBA_ArrayDef__narrow :: a *World -> (MayBe CORBA_ArrayDef, *World)
instance CORBA_ArrayDef__narrow_class CORBA_IDLType
instance CORBA_ArrayDef__narrow_class CORBA_Object

class CORBA_ArrayDef__widen_class a where
	CORBA_ArrayDef__widen :: a -> CORBA_ArrayDef

instance CORBA_IDLType__widen_class CORBA_ArrayDef

instance CORBA_Object__widen_class CORBA_ArrayDef

CORBA_ArrayDef__get_length :: CORBA_ArrayDef  *World
	-> ((ResultOrException CORBA_ULong CorbaException), *World)

CORBA_ArrayDef__set_length :: CORBA_ArrayDef CORBA_ULong *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ArrayDef__get_element_type :: CORBA_ArrayDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_ArrayDef__get_element_type_def :: CORBA_ArrayDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_ArrayDef__set_element_type_def :: CORBA_ArrayDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_ExceptionDef
////////////////////////////////

:: CORBA_ExceptionDef  = { reference :: CORBA_Object }
CORBA_ExceptionDef__tc 	 :: TypeCode
CORBA_ExceptionDef__repoid 	:==	 "IDL:omg.org/CORBA/ExceptionDef:1.0"
CORBA_ExceptionDef__name 	:==	 "ExceptionDef"
CORBA_ExceptionDef__decode :: Any *World -> (MayBe CORBA_ExceptionDef, *World)
CORBA_ExceptionDef__encode :: CORBA_ExceptionDef -> Any
CORBA_ExceptionDef__nil :: *World -> (CORBA_ExceptionDef, *World)
class CORBA_ExceptionDef__narrow_class a where
	CORBA_ExceptionDef__narrow :: a *World -> (MayBe CORBA_ExceptionDef, *World)
instance CORBA_ExceptionDef__narrow_class CORBA_Contained
instance CORBA_ExceptionDef__narrow_class CORBA_Container
instance CORBA_ExceptionDef__narrow_class CORBA_Object

class CORBA_ExceptionDef__widen_class a where
	CORBA_ExceptionDef__widen :: a -> CORBA_ExceptionDef

instance CORBA_Contained__widen_class CORBA_ExceptionDef

instance CORBA_Container__widen_class CORBA_ExceptionDef

instance CORBA_Object__widen_class CORBA_ExceptionDef

CORBA_ExceptionDef__get_type :: CORBA_ExceptionDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_ExceptionDef__get_members :: CORBA_ExceptionDef  *World
	-> ((ResultOrException CORBA_StructMemberSeq CorbaException), *World)

CORBA_ExceptionDef__set_members :: CORBA_ExceptionDef CORBA_StructMemberSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_ExceptionDescription
////////////////////////////////

:: CORBA_ExceptionDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	type :: CORBA_TypeCode
	}
CORBA_ExceptionDescription__tc :: TypeCode
CORBA_ExceptionDescription__repoid 	:==	 "IDL:omg.org/CORBA/ExceptionDescription:1.0"
CORBA_ExceptionDescription__name 	:==	 "ExceptionDescription"
CORBA_ExceptionDescription__decode :: Any *World -> (MayBe CORBA_ExceptionDescription, *World)
CORBA_ExceptionDescription__encode :: CORBA_ExceptionDescription -> Any

////////////////////////////////
//     CORBA_AttributeMode
////////////////////////////////

:: CORBA_AttributeMode = ATTR_NORMAL
	| ATTR_READONLY
CORBA_AttributeMode__tc :: TypeCode
CORBA_AttributeMode__repoid 	:==	 "IDL:omg.org/CORBA/AttributeMode:1.0"
CORBA_AttributeMode__name 	:==	 "AttributeMode"
CORBA_AttributeMode__decode :: Any *World -> (MayBe CORBA_AttributeMode, *World)
CORBA_AttributeMode__encode :: CORBA_AttributeMode -> Any

instance == CORBA_AttributeMode

instance toString CORBA_AttributeMode

////////////////////////////////
//     CORBA_AttributeDef
////////////////////////////////

:: CORBA_AttributeDef  = { reference :: CORBA_Object }
CORBA_AttributeDef__tc 	 :: TypeCode
CORBA_AttributeDef__repoid 	:==	 "IDL:omg.org/CORBA/AttributeDef:1.0"
CORBA_AttributeDef__name 	:==	 "AttributeDef"
CORBA_AttributeDef__decode :: Any *World -> (MayBe CORBA_AttributeDef, *World)
CORBA_AttributeDef__encode :: CORBA_AttributeDef -> Any
CORBA_AttributeDef__nil :: *World -> (CORBA_AttributeDef, *World)
class CORBA_AttributeDef__narrow_class a where
	CORBA_AttributeDef__narrow :: a *World -> (MayBe CORBA_AttributeDef, *World)
instance CORBA_AttributeDef__narrow_class CORBA_Contained
instance CORBA_AttributeDef__narrow_class CORBA_Object

class CORBA_AttributeDef__widen_class a where
	CORBA_AttributeDef__widen :: a -> CORBA_AttributeDef

instance CORBA_Contained__widen_class CORBA_AttributeDef

instance CORBA_Object__widen_class CORBA_AttributeDef

CORBA_AttributeDef__get_type :: CORBA_AttributeDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_AttributeDef__get_type_def :: CORBA_AttributeDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_AttributeDef__set_type_def :: CORBA_AttributeDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_AttributeDef__get_mode :: CORBA_AttributeDef  *World
	-> ((ResultOrException CORBA_AttributeMode CorbaException), *World)

CORBA_AttributeDef__set_mode :: CORBA_AttributeDef CORBA_AttributeMode *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_AttributeDescription
////////////////////////////////

:: CORBA_AttributeDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	type :: CORBA_TypeCode,
	mode :: CORBA_AttributeMode
	}
CORBA_AttributeDescription__tc :: TypeCode
CORBA_AttributeDescription__repoid 	:==	 "IDL:omg.org/CORBA/AttributeDescription:1.0"
CORBA_AttributeDescription__name 	:==	 "AttributeDescription"
CORBA_AttributeDescription__decode :: Any *World -> (MayBe CORBA_AttributeDescription, *World)
CORBA_AttributeDescription__encode :: CORBA_AttributeDescription -> Any

////////////////////////////////
//     CORBA_OperationMode
////////////////////////////////

:: CORBA_OperationMode = OP_NORMAL
	| OP_ONEWAY
CORBA_OperationMode__tc :: TypeCode
CORBA_OperationMode__repoid 	:==	 "IDL:omg.org/CORBA/OperationMode:1.0"
CORBA_OperationMode__name 	:==	 "OperationMode"
CORBA_OperationMode__decode :: Any *World -> (MayBe CORBA_OperationMode, *World)
CORBA_OperationMode__encode :: CORBA_OperationMode -> Any

instance == CORBA_OperationMode

instance toString CORBA_OperationMode

////////////////////////////////
//     CORBA_ParameterMode
////////////////////////////////

:: CORBA_ParameterMode = PARAM_IN
	| PARAM_OUT
	| PARAM_INOUT
CORBA_ParameterMode__tc :: TypeCode
CORBA_ParameterMode__repoid 	:==	 "IDL:omg.org/CORBA/ParameterMode:1.0"
CORBA_ParameterMode__name 	:==	 "ParameterMode"
CORBA_ParameterMode__decode :: Any *World -> (MayBe CORBA_ParameterMode, *World)
CORBA_ParameterMode__encode :: CORBA_ParameterMode -> Any

instance == CORBA_ParameterMode

instance toString CORBA_ParameterMode

////////////////////////////////
//     CORBA_ParameterDescription
////////////////////////////////

:: CORBA_ParameterDescription = {
	name :: CORBA_Identifier,
	type :: CORBA_TypeCode,
	type_def :: CORBA_IDLType,
	mode :: CORBA_ParameterMode
	}
CORBA_ParameterDescription__tc :: TypeCode
CORBA_ParameterDescription__repoid 	:==	 "IDL:omg.org/CORBA/ParameterDescription:1.0"
CORBA_ParameterDescription__name 	:==	 "ParameterDescription"
CORBA_ParameterDescription__decode :: Any *World -> (MayBe CORBA_ParameterDescription, *World)
CORBA_ParameterDescription__encode :: CORBA_ParameterDescription -> Any

////////////////////////////////
//     CORBA_ParDescriptionSeq
////////////////////////////////

:: CORBA_ParDescriptionSeq :== [CORBA_ParameterDescription]
CORBA_ParDescriptionSeq__tc :: TypeCode
CORBA_ParDescriptionSeq__decode :: Any *World -> (MayBe CORBA_ParDescriptionSeq, *World)
CORBA_ParDescriptionSeq__encode :: CORBA_ParDescriptionSeq -> Any

////////////////////////////////
//     CORBA_ContextIdentifier
////////////////////////////////

:: CORBA_ContextIdentifier :== CORBA_Identifier
CORBA_ContextIdentifier__tc :: TypeCode
CORBA_ContextIdentifier__repoid 	:==	 "IDL:omg.org/CORBA/ContextIdentifier:1.0"
CORBA_ContextIdentifier__name 	:==	 "ContextIdentifier"
CORBA_ContextIdentifier__decode :== CORBA_Identifier__decode
CORBA_ContextIdentifier__encode :== CORBA_Identifier__encode

////////////////////////////////
//     CORBA_ContextIdSeq
////////////////////////////////

:: CORBA_ContextIdSeq :== [CORBA_ContextIdentifier]
CORBA_ContextIdSeq__tc :: TypeCode
CORBA_ContextIdSeq__decode :: Any *World -> (MayBe CORBA_ContextIdSeq, *World)
CORBA_ContextIdSeq__encode :: CORBA_ContextIdSeq -> Any

////////////////////////////////
//     CORBA_ExceptionDefSeq
////////////////////////////////

:: CORBA_ExceptionDefSeq :== [CORBA_ExceptionDef]
CORBA_ExceptionDefSeq__tc :: TypeCode
CORBA_ExceptionDefSeq__decode :: Any *World -> (MayBe CORBA_ExceptionDefSeq, *World)
CORBA_ExceptionDefSeq__encode :: CORBA_ExceptionDefSeq -> Any

////////////////////////////////
//     CORBA_ExcDescriptionSeq
////////////////////////////////

:: CORBA_ExcDescriptionSeq :== [CORBA_ExceptionDescription]
CORBA_ExcDescriptionSeq__tc :: TypeCode
CORBA_ExcDescriptionSeq__decode :: Any *World -> (MayBe CORBA_ExcDescriptionSeq, *World)
CORBA_ExcDescriptionSeq__encode :: CORBA_ExcDescriptionSeq -> Any

////////////////////////////////
//     CORBA_OperationDef
////////////////////////////////

:: CORBA_OperationDef  = { reference :: CORBA_Object }
CORBA_OperationDef__tc 	 :: TypeCode
CORBA_OperationDef__repoid 	:==	 "IDL:omg.org/CORBA/OperationDef:1.0"
CORBA_OperationDef__name 	:==	 "OperationDef"
CORBA_OperationDef__decode :: Any *World -> (MayBe CORBA_OperationDef, *World)
CORBA_OperationDef__encode :: CORBA_OperationDef -> Any
CORBA_OperationDef__nil :: *World -> (CORBA_OperationDef, *World)
class CORBA_OperationDef__narrow_class a where
	CORBA_OperationDef__narrow :: a *World -> (MayBe CORBA_OperationDef, *World)
instance CORBA_OperationDef__narrow_class CORBA_Contained
instance CORBA_OperationDef__narrow_class CORBA_Object

class CORBA_OperationDef__widen_class a where
	CORBA_OperationDef__widen :: a -> CORBA_OperationDef

instance CORBA_Contained__widen_class CORBA_OperationDef

instance CORBA_Object__widen_class CORBA_OperationDef

CORBA_OperationDef__get_result :: CORBA_OperationDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_OperationDef__get_result_def :: CORBA_OperationDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_OperationDef__set_result_def :: CORBA_OperationDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_OperationDef__get_params :: CORBA_OperationDef  *World
	-> ((ResultOrException CORBA_ParDescriptionSeq CorbaException), *World)

CORBA_OperationDef__set_params :: CORBA_OperationDef CORBA_ParDescriptionSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_OperationDef__get_mode :: CORBA_OperationDef  *World
	-> ((ResultOrException CORBA_OperationMode CorbaException), *World)

CORBA_OperationDef__set_mode :: CORBA_OperationDef CORBA_OperationMode *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_OperationDef__get_contexts :: CORBA_OperationDef  *World
	-> ((ResultOrException CORBA_ContextIdSeq CorbaException), *World)

CORBA_OperationDef__set_contexts :: CORBA_OperationDef CORBA_ContextIdSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_OperationDef__get_exceptions :: CORBA_OperationDef  *World
	-> ((ResultOrException CORBA_ExceptionDefSeq CorbaException), *World)

CORBA_OperationDef__set_exceptions :: CORBA_OperationDef CORBA_ExceptionDefSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_OperationDescription
////////////////////////////////

:: CORBA_OperationDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	result :: CORBA_TypeCode,
	mode :: CORBA_OperationMode,
	contexts :: CORBA_ContextIdSeq,
	parameters :: CORBA_ParDescriptionSeq,
	exceptions :: CORBA_ExcDescriptionSeq
	}
CORBA_OperationDescription__tc :: TypeCode
CORBA_OperationDescription__repoid 	:==	 "IDL:omg.org/CORBA/OperationDescription:1.0"
CORBA_OperationDescription__name 	:==	 "OperationDescription"
CORBA_OperationDescription__decode :: Any *World -> (MayBe CORBA_OperationDescription, *World)
CORBA_OperationDescription__encode :: CORBA_OperationDescription -> Any

////////////////////////////////
//     CORBA_RepositoryIdSeq
////////////////////////////////

:: CORBA_RepositoryIdSeq :== [CORBA_RepositoryId]
CORBA_RepositoryIdSeq__tc :: TypeCode
CORBA_RepositoryIdSeq__decode :: Any *World -> (MayBe CORBA_RepositoryIdSeq, *World)
CORBA_RepositoryIdSeq__encode :: CORBA_RepositoryIdSeq -> Any

////////////////////////////////
//     CORBA_OpDescriptionSeq
////////////////////////////////

:: CORBA_OpDescriptionSeq :== [CORBA_OperationDescription]
CORBA_OpDescriptionSeq__tc :: TypeCode
CORBA_OpDescriptionSeq__decode :: Any *World -> (MayBe CORBA_OpDescriptionSeq, *World)
CORBA_OpDescriptionSeq__encode :: CORBA_OpDescriptionSeq -> Any

////////////////////////////////
//     CORBA_AttrDescriptionSeq
////////////////////////////////

:: CORBA_AttrDescriptionSeq :== [CORBA_AttributeDescription]
CORBA_AttrDescriptionSeq__tc :: TypeCode
CORBA_AttrDescriptionSeq__decode :: Any *World -> (MayBe CORBA_AttrDescriptionSeq, *World)
CORBA_AttrDescriptionSeq__encode :: CORBA_AttrDescriptionSeq -> Any

////////////////////////////////
//     CORBA_InterfaceDef
////////////////////////////////

:: CORBA_InterfaceDef  = { reference :: CORBA_Object }
CORBA_InterfaceDef__tc 	 :: TypeCode
CORBA_InterfaceDef__repoid 	:==	 "IDL:omg.org/CORBA/InterfaceDef:1.0"
CORBA_InterfaceDef__name 	:==	 "InterfaceDef"
CORBA_InterfaceDef__decode :: Any *World -> (MayBe CORBA_InterfaceDef, *World)
CORBA_InterfaceDef__encode :: CORBA_InterfaceDef -> Any
CORBA_InterfaceDef__nil :: *World -> (CORBA_InterfaceDef, *World)
class CORBA_InterfaceDef__narrow_class a where
	CORBA_InterfaceDef__narrow :: a *World -> (MayBe CORBA_InterfaceDef, *World)
instance CORBA_InterfaceDef__narrow_class CORBA_Container
instance CORBA_InterfaceDef__narrow_class CORBA_Contained
instance CORBA_InterfaceDef__narrow_class CORBA_IDLType
instance CORBA_InterfaceDef__narrow_class CORBA_Object

class CORBA_InterfaceDef__widen_class a where
	CORBA_InterfaceDef__widen :: a -> CORBA_InterfaceDef

instance CORBA_Container__widen_class CORBA_InterfaceDef

instance CORBA_Contained__widen_class CORBA_InterfaceDef

instance CORBA_IDLType__widen_class CORBA_InterfaceDef

instance CORBA_Object__widen_class CORBA_InterfaceDef

CORBA_InterfaceDef__get_base_interfaces :: CORBA_InterfaceDef  *World
	-> ((ResultOrException CORBA_InterfaceDefSeq CorbaException), *World)

CORBA_InterfaceDef__set_base_interfaces :: CORBA_InterfaceDef CORBA_InterfaceDefSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_InterfaceDef__get_is_abstract :: CORBA_InterfaceDef  *World
	-> ((ResultOrException CORBA_Boolean CorbaException), *World)

CORBA_InterfaceDef__set_is_abstract :: CORBA_InterfaceDef CORBA_Boolean *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_InterfaceDef_is_a :: CORBA_InterfaceDef CORBA_RepositoryId *World
	-> ((ResultOrException CORBA_Boolean CorbaException), *World)

////////////////////////////////
//     CORBA_InterfaceDef_FullInterfaceDescription
////////////////////////////////

:: CORBA_InterfaceDef_FullInterfaceDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	operations :: CORBA_OpDescriptionSeq,
	attributes :: CORBA_AttrDescriptionSeq,
	base_interfaces :: CORBA_RepositoryIdSeq,
	type :: CORBA_TypeCode,
	is_abstract :: CORBA_Boolean
	}
CORBA_InterfaceDef_FullInterfaceDescription__tc :: TypeCode
CORBA_InterfaceDef_FullInterfaceDescription__repoid 	:==	 "IDL:omg.org/CORBA/InterfaceDef/FullInterfaceDescription:1.0"
CORBA_InterfaceDef_FullInterfaceDescription__name 	:==	 "FullInterfaceDescription"
CORBA_InterfaceDef_FullInterfaceDescription__decode :: Any *World -> (MayBe CORBA_InterfaceDef_FullInterfaceDescription, *World)
CORBA_InterfaceDef_FullInterfaceDescription__encode :: CORBA_InterfaceDef_FullInterfaceDescription -> Any

CORBA_InterfaceDef_describe_interface :: CORBA_InterfaceDef  *World
	-> ((ResultOrException CORBA_InterfaceDef_FullInterfaceDescription CorbaException), *World)

CORBA_InterfaceDef_create_attribute :: CORBA_InterfaceDef CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_AttributeMode *World
	-> ((ResultOrException CORBA_AttributeDef CorbaException), *World)

CORBA_InterfaceDef_create_operation :: CORBA_InterfaceDef CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_OperationMode CORBA_ParDescriptionSeq CORBA_ExceptionDefSeq CORBA_ContextIdSeq *World
	-> ((ResultOrException CORBA_OperationDef CorbaException), *World)

////////////////////////////////
//     CORBA_InterfaceDescription
////////////////////////////////

:: CORBA_InterfaceDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	base_interfaces :: CORBA_RepositoryIdSeq,
	is_abstract :: CORBA_Boolean
	}
CORBA_InterfaceDescription__tc :: TypeCode
CORBA_InterfaceDescription__repoid 	:==	 "IDL:omg.org/CORBA/InterfaceDescription:1.0"
CORBA_InterfaceDescription__name 	:==	 "InterfaceDescription"
CORBA_InterfaceDescription__decode :: Any *World -> (MayBe CORBA_InterfaceDescription, *World)
CORBA_InterfaceDescription__encode :: CORBA_InterfaceDescription -> Any

////////////////////////////////
//     CORBA_ValueMemberDef
////////////////////////////////

:: CORBA_ValueMemberDef  = { reference :: CORBA_Object }
CORBA_ValueMemberDef__tc 	 :: TypeCode
CORBA_ValueMemberDef__repoid 	:==	 "IDL:omg.org/CORBA/ValueMemberDef:1.0"
CORBA_ValueMemberDef__name 	:==	 "ValueMemberDef"
CORBA_ValueMemberDef__decode :: Any *World -> (MayBe CORBA_ValueMemberDef, *World)
CORBA_ValueMemberDef__encode :: CORBA_ValueMemberDef -> Any
CORBA_ValueMemberDef__nil :: *World -> (CORBA_ValueMemberDef, *World)
class CORBA_ValueMemberDef__narrow_class a where
	CORBA_ValueMemberDef__narrow :: a *World -> (MayBe CORBA_ValueMemberDef, *World)
instance CORBA_ValueMemberDef__narrow_class CORBA_Contained
instance CORBA_ValueMemberDef__narrow_class CORBA_Object

class CORBA_ValueMemberDef__widen_class a where
	CORBA_ValueMemberDef__widen :: a -> CORBA_ValueMemberDef

instance CORBA_Contained__widen_class CORBA_ValueMemberDef

instance CORBA_Object__widen_class CORBA_ValueMemberDef

CORBA_ValueMemberDef__get_type :: CORBA_ValueMemberDef  *World
	-> ((ResultOrException CORBA_TypeCode CorbaException), *World)

CORBA_ValueMemberDef__get_type_def :: CORBA_ValueMemberDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_ValueMemberDef__set_type_def :: CORBA_ValueMemberDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueMemberDef__get_access :: CORBA_ValueMemberDef  *World
	-> ((ResultOrException CORBA_Visibility CorbaException), *World)

CORBA_ValueMemberDef__set_access :: CORBA_ValueMemberDef CORBA_Visibility *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

////////////////////////////////
//     CORBA_ValueDef
////////////////////////////////

:: CORBA_ValueDef  = { reference :: CORBA_Object }
CORBA_ValueDef__tc 	 :: TypeCode
CORBA_ValueDef__repoid 	:==	 "IDL:omg.org/CORBA/ValueDef:1.0"
CORBA_ValueDef__name 	:==	 "ValueDef"
CORBA_ValueDef__decode :: Any *World -> (MayBe CORBA_ValueDef, *World)
CORBA_ValueDef__encode :: CORBA_ValueDef -> Any
CORBA_ValueDef__nil :: *World -> (CORBA_ValueDef, *World)
class CORBA_ValueDef__narrow_class a where
	CORBA_ValueDef__narrow :: a *World -> (MayBe CORBA_ValueDef, *World)
instance CORBA_ValueDef__narrow_class CORBA_Container
instance CORBA_ValueDef__narrow_class CORBA_Contained
instance CORBA_ValueDef__narrow_class CORBA_IDLType
instance CORBA_ValueDef__narrow_class CORBA_Object

class CORBA_ValueDef__widen_class a where
	CORBA_ValueDef__widen :: a -> CORBA_ValueDef

instance CORBA_Container__widen_class CORBA_ValueDef

instance CORBA_Contained__widen_class CORBA_ValueDef

instance CORBA_IDLType__widen_class CORBA_ValueDef

instance CORBA_Object__widen_class CORBA_ValueDef

CORBA_ValueDef__get_supported_interfaces :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_InterfaceDefSeq CorbaException), *World)

CORBA_ValueDef__set_supported_interfaces :: CORBA_ValueDef CORBA_InterfaceDefSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef__get_initializers :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_InitializerSeq CorbaException), *World)

CORBA_ValueDef__set_initializers :: CORBA_ValueDef CORBA_InitializerSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef__get_base_value :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_ValueDef CorbaException), *World)

CORBA_ValueDef__set_base_value :: CORBA_ValueDef CORBA_ValueDef *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef__get_abstract_base_values :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_ValueDefSeq CorbaException), *World)

CORBA_ValueDef__set_abstract_base_values :: CORBA_ValueDef CORBA_ValueDefSeq *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef__get_is_abstract :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_Boolean CorbaException), *World)

CORBA_ValueDef__set_is_abstract :: CORBA_ValueDef CORBA_Boolean *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef__get_is_custom :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_Boolean CorbaException), *World)

CORBA_ValueDef__set_is_custom :: CORBA_ValueDef CORBA_Boolean *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef__get_is_truncatable :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_Boolean CorbaException), *World)

CORBA_ValueDef__set_is_truncatable :: CORBA_ValueDef CORBA_Boolean *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

CORBA_ValueDef_is_a :: CORBA_ValueDef CORBA_RepositoryId *World
	-> ((ResultOrException CORBA_Boolean CorbaException), *World)

////////////////////////////////
//     CORBA_ValueDef_FullValueDescription
////////////////////////////////

:: CORBA_ValueDef_FullValueDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	is_abstract :: CORBA_Boolean,
	is_custom :: CORBA_Boolean,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	operations :: CORBA_OpDescriptionSeq,
	attributes :: CORBA_AttrDescriptionSeq,
	members :: CORBA_ValueMemberSeq,
	initializers :: CORBA_InitializerSeq,
	supported_interfaces :: CORBA_RepositoryIdSeq,
	abstract_base_values :: CORBA_RepositoryIdSeq,
	is_truncatable :: CORBA_Boolean,
	base_value :: CORBA_RepositoryId,
	type :: CORBA_TypeCode
	}
CORBA_ValueDef_FullValueDescription__tc :: TypeCode
CORBA_ValueDef_FullValueDescription__repoid 	:==	 "IDL:omg.org/CORBA/ValueDef/FullValueDescription:1.0"
CORBA_ValueDef_FullValueDescription__name 	:==	 "FullValueDescription"
CORBA_ValueDef_FullValueDescription__decode :: Any *World -> (MayBe CORBA_ValueDef_FullValueDescription, *World)
CORBA_ValueDef_FullValueDescription__encode :: CORBA_ValueDef_FullValueDescription -> Any

CORBA_ValueDef_describe_value :: CORBA_ValueDef  *World
	-> ((ResultOrException CORBA_ValueDef_FullValueDescription CorbaException), *World)

CORBA_ValueDef_create_value_member :: CORBA_ValueDef CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_Visibility *World
	-> ((ResultOrException CORBA_ValueMemberDef CorbaException), *World)

CORBA_ValueDef_create_attribute :: CORBA_ValueDef CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_AttributeMode *World
	-> ((ResultOrException CORBA_AttributeDef CorbaException), *World)

CORBA_ValueDef_create_operation :: CORBA_ValueDef CORBA_RepositoryId CORBA_Identifier CORBA_VersionSpec CORBA_IDLType CORBA_OperationMode CORBA_ParDescriptionSeq CORBA_ExceptionDefSeq CORBA_ContextIdSeq *World
	-> ((ResultOrException CORBA_OperationDef CorbaException), *World)

////////////////////////////////
//     CORBA_ValueDescription
////////////////////////////////

:: CORBA_ValueDescription = {
	name :: CORBA_Identifier,
	id :: CORBA_RepositoryId,
	is_abstract :: CORBA_Boolean,
	is_custom :: CORBA_Boolean,
	defined_in :: CORBA_RepositoryId,
	version :: CORBA_VersionSpec,
	supported_interfaces :: CORBA_RepositoryIdSeq,
	abstract_base_values :: CORBA_RepositoryIdSeq,
	is_truncatable :: CORBA_Boolean,
	base_value :: CORBA_RepositoryId
	}
CORBA_ValueDescription__tc :: TypeCode
CORBA_ValueDescription__repoid 	:==	 "IDL:omg.org/CORBA/ValueDescription:1.0"
CORBA_ValueDescription__name 	:==	 "ValueDescription"
CORBA_ValueDescription__decode :: Any *World -> (MayBe CORBA_ValueDescription, *World)
CORBA_ValueDescription__encode :: CORBA_ValueDescription -> Any

////////////////////////////////
//     CORBA_ValueBoxDef
////////////////////////////////

:: CORBA_ValueBoxDef  = { reference :: CORBA_Object }
CORBA_ValueBoxDef__tc 	 :: TypeCode
CORBA_ValueBoxDef__repoid 	:==	 "IDL:omg.org/CORBA/ValueBoxDef:1.0"
CORBA_ValueBoxDef__name 	:==	 "ValueBoxDef"
CORBA_ValueBoxDef__decode :: Any *World -> (MayBe CORBA_ValueBoxDef, *World)
CORBA_ValueBoxDef__encode :: CORBA_ValueBoxDef -> Any
CORBA_ValueBoxDef__nil :: *World -> (CORBA_ValueBoxDef, *World)
class CORBA_ValueBoxDef__narrow_class a where
	CORBA_ValueBoxDef__narrow :: a *World -> (MayBe CORBA_ValueBoxDef, *World)
instance CORBA_ValueBoxDef__narrow_class CORBA_TypedefDef
instance CORBA_ValueBoxDef__narrow_class CORBA_Object

class CORBA_ValueBoxDef__widen_class a where
	CORBA_ValueBoxDef__widen :: a -> CORBA_ValueBoxDef

instance CORBA_TypedefDef__widen_class CORBA_ValueBoxDef

instance CORBA_Object__widen_class CORBA_ValueBoxDef

CORBA_ValueBoxDef__get_original_type_def :: CORBA_ValueBoxDef  *World
	-> ((ResultOrException CORBA_IDLType CorbaException), *World)

CORBA_ValueBoxDef__set_original_type_def :: CORBA_ValueBoxDef CORBA_IDLType *World
	-> ((ResultOrException CORBA_Void CorbaException), *World)

